if (typeof window !== 'undefined') {
	require('./tools/MapSetPolyfill');
}

module.exports = {
	Bus: require('./src/goo/entities/Bus'),
	CameraComponent: require('./src/goo/entities/components/CameraComponent'),
	Component: require('./src/goo/entities/components/Component'),
	CssTransformComponent: require('./src/goo/entities/components/CssTransformComponent'),
	Dom3dComponent: require('./src/goo/entities/components/Dom3dComponent'),
	HtmlComponent: require('./src/goo/entities/components/HtmlComponent'),
	LightComponent: require('./src/goo/entities/components/LightComponent'),
	MeshDataComponent: require('./src/goo/entities/components/MeshDataComponent'),
	MeshRendererComponent: require('./src/goo/entities/components/MeshRendererComponent'),
	MovementComponent: require('./src/goo/entities/components/MovementComponent'),
	ParticleComponent: require('./src/goo/entities/components/ParticleComponent'),
	PortalComponent: require('./src/goo/entities/components/PortalComponent'),
	ScriptComponent: require('./src/goo/entities/components/ScriptComponent'),
	SoundComponent: require('./src/goo/entities/components/SoundComponent'),
	TextComponent: require('./src/goo/entities/components/TextComponent'),
	TransformComponent: require('./src/goo/entities/components/TransformComponent'),
	Entity: require('./src/goo/entities/Entity'),
	EntitySelection: require('./src/goo/entities/EntitySelection'),
	EntityUtils: require('./src/goo/entities/EntityUtils'),
	GooRunner: require('./src/goo/entities/GooRunner'),
	EntityManager: require('./src/goo/entities/managers/EntityManager'),
	Manager: require('./src/goo/entities/managers/Manager'),
	Selection: require('./src/goo/entities/Selection'),
	SystemBus: require('./src/goo/entities/SystemBus'),
	BoundingUpdateSystem: require('./src/goo/entities/systems/BoundingUpdateSystem'),
	CameraSystem: require('./src/goo/entities/systems/CameraSystem'),
	CssTransformSystem: require('./src/goo/entities/systems/CssTransformSystem'),
	Dom3dSystem: require('./src/goo/entities/systems/Dom3dSystem'),
	GridRenderSystem: require('./src/goo/entities/systems/GridRenderSystem'),
	HtmlSystem: require('./src/goo/entities/systems/HtmlSystem'),
	LightingSystem: require('./src/goo/entities/systems/LightingSystem'),
	MovementSystem: require('./src/goo/entities/systems/MovementSystem'),
	ParticlesSystem: require('./src/goo/entities/systems/ParticlesSystem'),
	PickingSystem: require('./src/goo/entities/systems/PickingSystem'),
	PipRenderSystem: require('./src/goo/entities/systems/PipRenderSystem'),
	PortalSystem: require('./src/goo/entities/systems/PortalSystem'),
	RenderSystem: require('./src/goo/entities/systems/RenderSystem'),
	ScriptSystem: require('./src/goo/entities/systems/ScriptSystem'),
	SoundSystem: require('./src/goo/entities/systems/SoundSystem'),
	System: require('./src/goo/entities/systems/System'),
	TextSystem: require('./src/goo/entities/systems/TextSystem'),
	TransformSystem: require('./src/goo/entities/systems/TransformSystem'),
	World: require('./src/goo/entities/World'),
	CrunchLoader: require('./src/goo/loaders/crunch/CrunchLoader'),
	DdsLoader: require('./src/goo/loaders/dds/DdsLoader'),
	DdsUtils: require('./src/goo/loaders/dds/DdsUtils'),
	DynamicLoader: require('./src/goo/loaders/DynamicLoader'),
	CameraComponentHandler: require('./src/goo/loaders/handlers/CameraComponentHandler'),
	ComponentHandler: require('./src/goo/loaders/handlers/ComponentHandler'),
	ConfigHandler: require('./src/goo/loaders/handlers/ConfigHandler'),
	Dom3dComponentHandler: require('./src/goo/loaders/handlers/Dom3dComponentHandler'),
	EntityHandler: require('./src/goo/loaders/handlers/EntityHandler'),
	EnvironmentHandler: require('./src/goo/loaders/handlers/EnvironmentHandler'),
	HtmlComponentHandler: require('./src/goo/loaders/handlers/HtmlComponentHandler'),
	LightComponentHandler: require('./src/goo/loaders/handlers/LightComponentHandler'),
	MaterialHandler: require('./src/goo/loaders/handlers/MaterialHandler'),
	MeshDataComponentHandler: require('./src/goo/loaders/handlers/MeshDataComponentHandler'),
	MeshDataHandler: require('./src/goo/loaders/handlers/MeshDataHandler'),
	MeshRendererComponentHandler: require('./src/goo/loaders/handlers/MeshRendererComponentHandler'),
	ProjectHandler: require('./src/goo/loaders/handlers/ProjectHandler'),
	SceneHandler: require('./src/goo/loaders/handlers/SceneHandler'),
	ShaderHandler: require('./src/goo/loaders/handlers/ShaderHandler'),
	SkyboxHandler: require('./src/goo/loaders/handlers/SkyboxHandler'),
	SoundComponentHandler: require('./src/goo/loaders/handlers/SoundComponentHandler'),
	SoundHandler: require('./src/goo/loaders/handlers/SoundHandler'),
	TextureHandler: require('./src/goo/loaders/handlers/TextureHandler'),
	TransformComponentHandler: require('./src/goo/loaders/handlers/TransformComponentHandler'),
	TgaLoader: require('./src/goo/loaders/tga/TgaLoader'),
	MathUtils: require('./src/goo/math/MathUtils'),
	Matrix: require('./src/goo/math/Matrix'),
	Matrix2: require('./src/goo/math/Matrix2'),
	Matrix2x2: require('./src/goo/math/Matrix2x2'),
	Matrix3: require('./src/goo/math/Matrix3'),
	Matrix3x3: require('./src/goo/math/Matrix3x3'),
	Matrix4: require('./src/goo/math/Matrix4'),
	Matrix4x4: require('./src/goo/math/Matrix4x4'),
	Plane: require('./src/goo/math/Plane'),
	Quaternion: require('./src/goo/math/Quaternion'),
	Ray: require('./src/goo/math/Ray'),
	Spline: require('./src/goo/math/splines/Spline'),
	SplineWalker: require('./src/goo/math/splines/SplineWalker'),
	Transform: require('./src/goo/math/Transform'),
	Vector: require('./src/goo/math/Vector'),
	Vector2: require('./src/goo/math/Vector2'),
	Vector3: require('./src/goo/math/Vector3'),
	Vector4: require('./src/goo/math/Vector4'),
	Noise: require('./src/goo/noise/Noise'),
	ValueNoise: require('./src/goo/noise/ValueNoise'),
	Particle: require('./src/goo/particles/Particle'),
	ParticleEmitter: require('./src/goo/particles/ParticleEmitter'),
	ParticleInfluence: require('./src/goo/particles/ParticleInfluence'),
	ParticleLib: require('./src/goo/particles/ParticleLib'),
	ParticleUtils: require('./src/goo/particles/ParticleUtils'),
	BoundingTree: require('./src/goo/picking/BoundingTree'),
	PrimitivePickLogic: require('./src/goo/picking/PrimitivePickLogic'),
	BoundingBox: require('./src/goo/renderer/bounds/BoundingBox'),
	BoundingSphere: require('./src/goo/renderer/bounds/BoundingSphere'),
	BoundingVolume: require('./src/goo/renderer/bounds/BoundingVolume'),
	BufferData: require('./src/goo/renderer/BufferData'),
	BufferUtils: require('./src/goo/renderer/BufferUtils'),
	Camera: require('./src/goo/renderer/Camera'),
	Capabilities: require('./src/goo/renderer/Capabilities'),
	DirectionalLight: require('./src/goo/renderer/light/DirectionalLight'),
	Light: require('./src/goo/renderer/light/Light'),
	PointLight: require('./src/goo/renderer/light/PointLight'),
	SpotLight: require('./src/goo/renderer/light/SpotLight'),
	Material: require('./src/goo/renderer/Material'),
	MeshData: require('./src/goo/renderer/MeshData'),
	Composer: require('./src/goo/renderer/pass/Composer'),
	FullscreenPass: require('./src/goo/renderer/pass/FullscreenPass'),
	FullscreenUtil: require('./src/goo/renderer/pass/FullscreenUtil'),
	FullscreenUtils: require('./src/goo/renderer/pass/FullscreenUtils'),
	Pass: require('./src/goo/renderer/pass/Pass'),
	RenderPass: require('./src/goo/renderer/pass/RenderPass'),
	RenderTarget: require('./src/goo/renderer/pass/RenderTarget'),
	ContextLost: require('./src/goo/renderer/Renderer+ContextLost'),
	Renderer: require('./src/goo/renderer/Renderer'),
	RendererRecord: require('./src/goo/renderer/RendererRecord'),
	RendererUtils: require('./src/goo/renderer/RendererUtils'),
	RenderInfo: require('./src/goo/renderer/RenderInfo'),
	RenderQueue: require('./src/goo/renderer/RenderQueue'),
	RenderStats: require('./src/goo/renderer/RenderStats'),
	Shader: require('./src/goo/renderer/Shader'),
	ShaderCall: require('./src/goo/renderer/ShaderCall'),
	ShaderBuilder: require('./src/goo/renderer/shaders/ShaderBuilder'),
	ShaderFragment: require('./src/goo/renderer/shaders/ShaderFragment'),
	ShaderLib: require('./src/goo/renderer/shaders/ShaderLib'),
	ShadowHandler: require('./src/goo/renderer/shadow/ShadowHandler'),
	SimplePartitioner: require('./src/goo/renderer/SimplePartitioner'),
	TaskScheduler: require('./src/goo/renderer/TaskScheduler'),
	Texture: require('./src/goo/renderer/Texture'),
	TextureCreator: require('./src/goo/renderer/TextureCreator'),
	OrbitCamControlScript: require('./src/goo/scripts/OrbitCamControlScript'),
	Scripts: require('./src/goo/scripts/Scripts'),
	ScriptUtils: require('./src/goo/scripts/ScriptUtils'),
	Box: require('./src/goo/shapes/Box'),
	Cone: require('./src/goo/shapes/Cone'),
	Cylinder: require('./src/goo/shapes/Cylinder'),
	Disk: require('./src/goo/shapes/Disk'),
	Grid: require('./src/goo/shapes/Grid'),
	Quad: require('./src/goo/shapes/Quad'),
	SimpleBox: require('./src/goo/shapes/SimpleBox'),
	Sphere: require('./src/goo/shapes/Sphere'),
	TextureGrid: require('./src/goo/shapes/TextureGrid'),
	Torus: require('./src/goo/shapes/Torus'),
	AudioContext: require('./src/goo/sound/AudioContext'),
	OscillatorSound: require('./src/goo/sound/OscillatorSound'),
	Sound: require('./src/goo/sound/Sound'),
	Ajax: require('./src/goo/util/Ajax'),
	ArrayUtil: require('./src/goo/util/ArrayUtil'),
	ArrayUtils: require('./src/goo/util/ArrayUtils'),
	CanvasUtils: require('./src/goo/util/CanvasUtils'),
	AtlasNode: require('./src/goo/util/combine/AtlasNode'),
	EntityCombiner: require('./src/goo/util/combine/EntityCombiner'),
	Rectangle: require('./src/goo/util/combine/Rectangle'),
	EventTarget: require('./src/goo/util/EventTarget'),
	GameUtils: require('./src/goo/util/GameUtils'),
	Logo: require('./src/goo/util/Logo'),
	MeshBuilder: require('./src/goo/util/MeshBuilder'),
	ObjectUtil: require('./src/goo/util/ObjectUtil'),
	ObjectUtils: require('./src/goo/util/ObjectUtils'),
	ParticleSystemUtils: require('./src/goo/util/ParticleSystemUtils'),
	PromiseUtil: require('./src/goo/util/PromiseUtil'),
	PromiseUtils: require('./src/goo/util/PromiseUtils'),
	Rc4Random: require('./src/goo/util/Rc4Random'),
	rsvp: require('./src/goo/util/rsvp'),
	ShapeCreatorMemoized: require('./src/goo/util/ShapeCreatorMemoized'),
	Skybox: require('./src/goo/util/Skybox'),
	Snow: require('./src/goo/util/Snow'),
	SoundCreator: require('./src/goo/util/SoundCreator'),
	Stats: require('./src/goo/util/Stats'),
	StringUtil: require('./src/goo/util/StringUtil'),
	StringUtils: require('./src/goo/util/StringUtils'),
	TangentGenerator: require('./src/goo/util/TangentGenerator'),
	Easing: require('./src/goo/util/Easing')
};

if (typeof(window) !== 'undefined') {
	window.goo = module.exports;
}